#overlap_bed_precise.awk

#idem as overlap_bed.awk meaning compares each line of a gff to all lines of a bed for overlap,
#except that here we do the comparison only if the gene name of the gff line (in fldgn) corresponds 
#to the bed gene line ($4) 
#Rk: can be used with a bed file of genes or exons

#awk -v fldgn=12 -v toadd="idxgn" -v fileRef="/home/ug/sdjebali/QuestionsQ1-Q3/Q3/Annotation/Q3_genes.bed" -f overlap_bed_precise.awk racefrags99_withdistclosestgn_withorient_overbadprobes.gff 

#awk -v fldgn=12 -v toadd="idxex" -v fileRef="/home/ug/sdjebali/QuestionsQ1-Q3/Q3/Annotation/Q3_genes_exons.bed" -f overlap_bed_precise.awk racefrags99_withdistclosestgn_withorient_overbadprobes.gff | awk '$NF==1' | wc -l

#/home/ug/sdjebali/QuestionsQ1-Q3/Q3/nnotation/Q3_genes.bed
#chr22   39091095        39130615        RP5-1042K10.2   0       +

#racefrags99_withdistclosestgn_withorient_overbadprobes.gff 
#chr21 10 racefrag 18049870 18049899 . . . dist= 489122 closgn= NM_024944 strand= + overlap= 0 assign= 1 overlap: 0 nboverlapped: 0
#here the gene name is in the 12th field


BEGIN{while (getline < fileRef >0)
  {
    exists[$4]=1;
    nbfeat[$4]++;
    chr[$4,nbfeat[$4]]=$1;
    beg[$4,nbfeat[$4]]=$2+1;    #bed file 
    end[$4,nbfeat[$4]]=$3;
    str[$4,nbfeat[$4]]=$6;
  }
}

{overlap=0;
 k=1;

 if(exists[$fldgn]==1)
 {
   while((overlap==0)&&(k<=nbfeat[$fldgn]))
     {
       if(foverlap($4,$5,beg[$fldgn,k],end[$fldgn,k]))
	 {
	   overlap=1;
	 }
       k++;
     }
 }

 print $0" ovlp_"toadd": "overlap;
}


#typically beg1,end1 are the positions in the gff file and beg2,end2 the positions in the bed file
#we need either beg2 or end2 to be in the interval [|beg1,end1|] or beg1 or end1 to be in the interval [|beg2,end2|]
function foverlap(beg1,end1,beg2,end2)
{
  return ((end1>=beg2)&&(beg1<=end2)) ? 1 : 0;
}

#((beg1<=beg2)&&(beg2<=end1))||((beg1<=end2)&&(end2<=end1))||((beg2<=beg1)&&(beg1<=end2))||((beg2<=end1)&&(end1<=end2))
