#overlap_better_gff.awk
#same as overla_better.awk except that fileRef is also a gff file
#to test better when encapsulated in a shell script

#awk -v toadd=A -v fileRef=Aobjects_sorted.gff -f ~/Awk/overlap_better_gff.awk Bobjects_sorted.gff


BEGIN{
  #store features of type A (fileRef param file)
  while(getline < fileRef >0)
    {
      nbA[$1]++;
      begA[$1,nbA[$1]]=$4; #since bed format
      endA[$1,nbA[$1]]=$5;
    }
}



{ 
  #store features of type B (input file)
  nbB[$1]++;
  begB[$1,nbB[$1]]=$4;
  endB[$1,nbB[$1]]=$5;
  line[$1,nbB[$1]]=$0;
}


END{
  #Go along features A and B of each chr at the same time (for all chr where there is at least one B feature)
  for(c in nbB)
    {
      iA=1;
      for(iB=1; iB<=nbB[c]; iB++)
	{
	  while((iA<=nbA[c])&&(endA[c,iA]<begB[c,iB]))
	    {
	      iA++;
	    }
	  if((iA<=nbA[c])&&(begA[c,iA]<=endB[c,iB]))   # iA<=nbA[c] means that endA[c,iA]>=begB[c,iB] so to have the overlap condition 
                                                       # we only need as a second condition begA[c,iA]<=endB[c,iB] 
	    {
	      print line[c,iB]" over_"(toadd)": 1";
	    }
	  else
	    {
	      print line[c,iB]" over_"(toadd)": 0";
	    }
	}
    }
}


